#ifndef CLASSLIB_ARRAY_H
#define CLASSLIB_ARRAY_H

template <class T>
class Array
{
public:
	typedef T* TPtr;
protected:
	TPtr* Data;
	int Size;
	int MaxSize;
public:
	
	Array ()
	{
		MaxSize = Size = 0;
		Data=NULL;
	};
	Array (int size)
	{
		Size = 0;
		MaxSize = size;
		Data = new TPtr [MaxSize];
	}
	Array (Array &array)
	{
		Size = 0;
		MaxSize = array.Size;
		Data = new TPtr [MaxSize];
		Size = array.Size;
		for (int i = 0; i < Size; i++)
			Data [i] = new T (*array.Data [i]);
	}
	~Array ()
	{
		Clear ();
		if (Data) delete [] Data;
	}
	int GetSize ()
	{
		return Size;
	}
	void Clear ()
	{
		for (int i = 0; i < Size; i++)
			delete (Data [i]);
		Size = 0;
	}
	void Delete (int i)
	{
		if ((i >= 0) && (i < Size))
		{
			delete Data [i];
			for (int j = i + 1; j < Size; j++)
				Data [j - 1] = Data [j];
			Size--;
		}
	}
	void Add (TPtr item)
	{
		if (Size == MaxSize)
		{
			MaxSize++;
			TPtr* NewData = new TPtr [MaxSize];
			for (int i = 0; i < Size; i++)
				NewData [i] = Data [i];
			if (Data) delete [] Data;
			Data = NewData;
		}
		Data [Size++] = item;
	}
	TPtr operator [] (int i)
	{
		return Data [i];
	}
};
#endif
